package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<I> {

  private I[] inputArray;

    public ArrayUtility(I[] inputArray) {
        this.inputArray= inputArray;
    }




    public Integer countDuplicatesInMerge(I[] arrayToMerge, I valueToEvaluate) {
        Integer count = 0;
        Object[] arr =  new Object[inputArray.length + arrayToMerge.length];

        System.arraycopy(inputArray, 0, arr, 0 , inputArray.length);
        System.arraycopy(arrayToMerge, 0, arr, inputArray.length , arrayToMerge.length);

        for(Object i : arr) if(i == valueToEvaluate) count+=1;

        return count;
    }


    public I getMostCommonFromMerge(I[] arrayToMerge) {
        Object[] arr = new Object[inputArray.length + arrayToMerge.length];
        System.arraycopy(inputArray, 0, arr, 0 , inputArray.length);
        System.arraycopy(arrayToMerge, 0, arr, inputArray.length , arrayToMerge.length);

        Integer count = 1, tempCount;
        Object common =  arr[0];
        Object temp;

        for (int i = 0; i < (arr.length - 1); i++)
        {
            temp = arr[i];
            tempCount = 0;
            for (int j = 1; j < arr.length; j++)
            {
                if (temp == arr[j])
                    tempCount++;
            }
            if (tempCount > count)
            {
                common = temp;
                count = tempCount;
            }
        }
        return (I) common;
    }

    public I[] removeValue(I valueToRemove) {
        ArrayList<I> arr = new ArrayList<>();
            for(I i: inputArray) if(i != valueToRemove) arr.add(i);

            I[] arr2 = (I[])Array.newInstance(inputArray.getClass().getComponentType(), arr.size());

        return arr.toArray(arr2);
    }


    public Integer getNumberOfOccurrences(I valueToEvaluate) {
        Integer count = 0;
        for(I i : inputArray) if(i == valueToEvaluate) count++;

        return count;
    }
}
